// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "MFCBsp.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	// code added for TrickyToolbar ...
	const int	URL_WIDTH = 200;
	int			index = 0;
	RECT		rect;


	// get index of our placeholder button in the toolbar ...
	while (m_wndToolBar.GetItemID(index) != ID_URL_DUMMY)
		index++;
	
	// next convert that button to a seperator and get its position ...
	m_wndToolBar.SetButtonInfo(index, ID_URL_DUMMY, TBBS_SEPARATOR, URL_WIDTH);
	m_wndToolBar.GetItemRect(index, &rect);
	
	// then .Create the combo box and show it
	if (!m_wndToolBar.m_URL.Create(WS_CHILD | WS_VISIBLE, rect, &m_wndToolBar, IDC_URL))
	{
		TRACE0("Failed to create edit control\n");
		return FALSE;
	}
	m_wndToolBar.m_URL.ShowWindow(SW_SHOW);
	
	
	
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

BOOL CMainFrame::PreTranslateMessage(MSG *pMsg)
{
	// check if the message is a keypress
	if ((pMsg->message >= WM_KEYFIRST) && (pMsg->message <= WM_KEYLAST))
	{
		CWnd*	pWnd = GetFocus();
		
		if (pWnd)
		{
			if (pMsg->wParam == VK_RETURN)
			{
				if (pWnd == &m_wndToolBar.m_URL)
				{
					CString	url;
					
					pWnd->GetWindowText(url);
					CHtmlView	*view = (CHtmlView *) GetActiveView();
					
					if (view)
					{
						view->Navigate2(url, NULL, NULL);
						
						// we handled the message ...
						return true;
					}
				}
			}
		}
	}
	// be a good citizen and call base class ...
	return CFrameWnd::PreTranslateMessage(pMsg);
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

